/* main.c */

#include <stm32f10x.h>
#include <stm32f10x_rcc.h>
#include <stm32f10x_gpio.h>
//#include <string.h>

#include "ws2812b.h"

void otherInit(void);

void Delay(uint32_t nTime);
uint8_t debounce(uint8_t last);


uint8_t tbuf[48 + NumberOfLEDS * 24 + 1]; //  !


int main(void)
{
	uint8_t currentButton;
	uint8_t lastButton;
	struct color Color1;

	uint8_t bttnSt = 0;

	otherInit(); // Initialize user button

	ws2812b_init(tbuf);

	lastButton = GPIO_ReadInputDataBit(GPIOA, GPIO_Pin_0);
	currentButton = lastButton;

	// Configure SysTick Timer
	if (SysTick_Config(SystemCoreClock / 1000))
			while (1);

	while (1)	{


		currentButton = debounce(lastButton);

		if ( lastButton == Bit_RESET && currentButton == Bit_SET ){

			if ( bttnSt == 0 ){

				//   "" 
				ws2812b_fillLEDsArray(tbuf, 0);

				Color1.G = 100;
				Color1.R = 0;
				Color1.B = 0;
				ws2812b_changeLed(tbuf, On, 1, &Color1);
				Color1.G = 0;
				Color1.R = 100;
				Color1.B = 0;
				ws2812b_changeLed(tbuf, On, 3, &Color1);
				Color1.G = 0;
				Color1.R = 0;
				Color1.B = 100;
				ws2812b_changeLed(tbuf, On, 5, &Color1);
				ws2812b_showLEDsArray();

				bttnSt++;
			} else if ( bttnSt == 1 ){

				ws2812b_changeLed(tbuf, Off, 3, 0);
				ws2812b_showLEDsArray();

				bttnSt++;
			}else if ( bttnSt == 2 ){

				Color1.G = 0;
				Color1.R = 10;
				Color1.B = 80;
				ws2812b_fillLEDsArray(tbuf, &Color1);
				ws2812b_showLEDsArray();
				bttnSt = 0;
			}

		}

		lastButton = currentButton;

	}//while

    return 0;
}

void otherInit(void){
	GPIO_InitTypeDef GPIO_InitStructure;

	// user button A0
	RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOA , ENABLE);
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_0;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN_FLOATING;
	GPIO_Init(GPIOA,	&GPIO_InitStructure);
}

static __IO uint32_t TimingDelay;

void Delay(uint32_t nTime){
	TimingDelay = nTime;
	while(TimingDelay != 0);
}


void SysTick_Handler(void){
	if (TimingDelay != 0x00)
		TimingDelay--;
}

uint8_t debounce(uint8_t last){
	uint8_t current = GPIO_ReadInputDataBit(GPIOA, GPIO_Pin_0);
	  if ( last != current ){
		  Delay(5);
		  current = GPIO_ReadInputDataBit(GPIOA, GPIO_Pin_0);
	  }
  return current;
}

#ifdef USE_FULL_ASSERT
void assert_failed(uint8_t *file, uint32_t line)
{
	/* Infinite loop */
	/* Use GDB to find out why we're here */
	while (1);
}
#endif
